function LRNLRmulticlass
  C=10;
  xb=[-5 5];
  yb=[-5 5];
  ClassIDs=[1 2 3 4 5];
  
  figure(1);clf;subplot(2,2,1);
  [X,y]=COMinputmulticlass(xb,yb,ClassIDs);
  
  [mlr,x]=COMlinLRmulti(X,C,y);
  lr1vs1=LRN1vs1(X,C,y);
  lr1vsA=LRN1vsA(X,C,y);

  cmap=plotdata(mlr,X,y,2,'MLR',xb,yb);
  cmap=plotdata(lr1vs1,X,y,3,'1-vs-1',xb,yb);
  cmap=plotdata(lr1vsA,X,y,4,'1-vs-All',xb,yb);
  
  NUMpts=100;
  maxclassify(mlr,xb,yb,NUMpts,2,cmap,'MLR');
  maxclassify(lr1vsA,xb,yb,NUMpts,4,cmap,'1-vs-All');
  majclassify(lr1vs1,xb,yb,NUMpts,3,cmap,'Maj 1-vs-1');
  dagclassify(lr1vs1,xb,yb,NUMpts,1,cmap,'Dag 1-vs-1');  
end

function dagclassify(lr,xb,yb,NUMpts,NUMplot,cmap,titlestr)
  NUMpts2=NUMpts*NUMpts;
  NUMclasses=length(lr.ClassIDs);
  xb=linspace(xb(1),xb(2),NUMpts);
  yb=linspace(yb(1),yb(2),NUMpts);
  [x1,x2]=meshgrid(xb,yb);
  x=[reshape(x1,1,NUMpts2);reshape(x2,1,NUMpts2)];
  predict=sign(lr.w'*x+repmat(lr.b,1,NUMpts2));
  predict(find(predict==0))=1;
  lrptr=ones(1,NUMpts2);
  dataptr=[1:NUMpts2];

  for k=1:NUMclasses-2,
    ind=sub2ind(size(predict),lrptr,dataptr);
    posind=find(predict(ind)==+1);
    negind=find(predict(ind)==-1);
    lrptr(posind)=lrptr(posind)+1;
    lrptr(negind)=1+NUMclasses*k-(k*(k+1)/2);
  end;
  ind=sub2ind(size(predict),lrptr,dataptr);
  posind=find(predict(ind)==+1);
  negind=find(predict(ind)==-1);

  c=zeros(size(lrptr));
  c(posind)=lr.posclass(lrptr(posind));
  c(negind)=lr.negclass(lrptr(negind));
  c=reshape(c,NUMpts,NUMpts);
  figure(2);subplot(2,2,NUMplot);colormap(cmap);
  image(flipud(c));title(titlestr);COMinvertfig;
end

function majclassify(lr,xb,yb,NUMpts,NUMplot,cmap,titlestr)
  NUMpts2=NUMpts*NUMpts;
  NUMclasses=length(lr.ClassIDs);
  xb=linspace(xb(1),xb(2),NUMpts);
  yb=linspace(yb(1),yb(2),NUMpts);
  [x1,x2]=meshgrid(xb,yb);
  x=[reshape(x1,1,NUMpts2);reshape(x2,1,NUMpts2)];
  predict=sign(lr.w'*x+repmat(lr.b,1,NUMpts2));
  predict(find(predict==0))=1;
  votes=zeros(NUMclasses,NUMpts2);
  for k=1:size(predict,1),
    posvoters=find(predict(k,:)==+1);
    negvoters=find(predict(k,:)==-1);
    votes(lr.posclass(k),posvoters)=votes(lr.posclass(k),posvoters)+1;
    votes(lr.negclass(k),negvoters)=votes(lr.negclass(k),negvoters)+1;
  end;
  [maxval,maxind]=max(votes);
  
  c=reshape(maxind,NUMpts,NUMpts);
  figure(2);subplot(2,2,NUMplot);colormap(cmap);
  image(flipud(c));title(titlestr);COMinvertfig;
end


function maxclassify(lr,xb,yb,NUMpts,NUMplot,cmap,titlestr)
  NUMpts2=NUMpts*NUMpts;
  xb=linspace(xb(1),xb(2),NUMpts);
  yb=linspace(yb(1),yb(2),NUMpts);
  [x1,x2]=meshgrid(xb,yb);
  x=[reshape(x1,1,NUMpts2);reshape(x2,1,NUMpts2)];
  predict=lr.w'*x+repmat(lr.b,1,NUMpts2);
  [maxval,maxind]=max(predict);
  c=reshape(maxind,NUMpts,NUMpts);
  
  figure(2);subplot(2,2,NUMplot);colormap(cmap);
  image(flipud(c));title(titlestr);COMinvertfig;
end

function lr=LRN1vs1(X,C,y)
  lr.ClassIDs=unique(y);
  NUMclasses=length(lr.ClassIDs);

  k=1;
  for i=1:NUMclasses-1,
    posclass=lr.ClassIDs(i);
    posind=find(y==posclass);
    for j=i+1:NUMclasses,
      negclass=lr.ClassIDs(j);
      negind=find(y==negclass);
      ind=[posind;negind];
      newy=[ones(size(posind));-ones(size(negind))];
      [lr1vs1,x]=COMlinLR(X(:,ind),C,newy);
      lr.w(:,k)=lr1vs1.w;lr.b(k)=lr1vs1.b;
      lr.posclass(k)=posclass;
      lr.negclass(k)=negclass;
      k=k+1;
    end;
  end;
  lr.b=lr.b';
end

function lr=LRN1vsA(X,C,y)
  NUMpts=length(y);
  lr.ClassIDs=unique(y);
  
  for i=1:length(lr.ClassIDs),
    posclass=lr.ClassIDs(i);
    posind=find(y==posclass);
    negind=find(y~=posclass);
    newy=repmat(-1,NUMpts,1);newy(posind)=1;
    [lr1vsA,x]=COMlinLR(X,C,newy);
    lr.w(:,i)=lr1vsA.w;lr.b(i)=lr1vsA.b;
  end;
  lr.b=lr.b';
end

function cmap=plotdata(mlr,X,y,plotnum,titlestr,xb,yb)
  subplot(2,2,plotnum);
  title(titlestr);
  colstr='rbygwmcrbygwmc';
  
  hold on;
  for k=1:length(mlr.ClassIDs),
    c=colstr(k);
    ind=find(y==mlr.ClassIDs(k));
    h=plot(X(1,ind),X(2,ind),[c,'o'],'MarkerFaceColor',c);
    cmap(k,:)=get(h,'Color');    
  end;
  for k=1:length(mlr.b),
    COMplotplane(xb,yb,mlr.w(:,k),mlr.b(k),[colstr(k),'-']);
  end;
  COMinvertfig;hold off;
end

