function LRNSVMmulticlass
  C=10;
  xb=[-5 5];
  yb=[-5 5];
  ClassIDs=[1 2 3 4 5];
  
  figure(1);clf;subplot(2,3,1);
  [X,y]=COMinputmulticlass(xb,yb,ClassIDs);
  title('Data');
  
  [msvm,x]=COMlinSVMmulti(X,C,y);
  [mlr,x]=COMlinLRmulti(X,C,y);
  svm1vs1=LRN1vs1(X,C,y);
  svm1vsA=LRN1vsA(X,C,y);

  cmap=plotdata(msvm,X,y,1,'MSVM',xb,yb);
  cmap=plotdata(mlr,X,y,2,'MLR',xb,yb);
  cmap=plotdata(svm1vs1,X,y,3,'1-vs-1',xb,yb);
  cmap=plotdata(svm1vsA,X,y,4,'1-vs-All',xb,yb);

  NUMpts=100;
  maxclassify(msvm,xb,yb,NUMpts,2,cmap,'MSVM');
  maxclassify(mlr,xb,yb,NUMpts,3,cmap,'MLR');
  maxclassify(svm1vsA,xb,yb,NUMpts,6,cmap,'1-vs-All');
  majclassify(svm1vs1,xb,yb,NUMpts,5,cmap,'Maj 1-vs-1');
  dagclassify(svm1vs1,xb,yb,NUMpts,4,cmap,'Dag 1-vs-1');  
end

function dagclassify(lr,xb,yb,NUMpts,NUMplot,cmap,titlestr)
  NUMpts2=NUMpts*NUMpts;
  NUMclasses=length(lr.ClassIDs);
  xb=linspace(xb(1),xb(2),NUMpts);
  yb=linspace(yb(1),yb(2),NUMpts);
  [x1,x2]=meshgrid(xb,yb);
  x=[reshape(x1,1,NUMpts2);reshape(x2,1,NUMpts2)];
  predict=sign(lr.w'*x+repmat(lr.b,1,NUMpts2));
  predict(find(predict==0))=1;
  lrptr=ones(1,NUMpts2);
  dataptr=[1:NUMpts2];

  for k=1:NUMclasses-2,
    ind=sub2ind(size(predict),lrptr,dataptr);
    posind=find(predict(ind)==+1);
    negind=find(predict(ind)==-1);
    lrptr(posind)=lrptr(posind)+1;
    lrptr(negind)=1+NUMclasses*k-(k*(k+1)/2);
  end;
  ind=sub2ind(size(predict),lrptr,dataptr);
  posind=find(predict(ind)==+1);
  negind=find(predict(ind)==-1);

  c=zeros(size(lrptr));
  c(posind)=lr.posclass(lrptr(posind));
  c(negind)=lr.negclass(lrptr(negind));
  c=reshape(c,NUMpts,NUMpts);
  plotdec(NUMplot,c,titlestr,xb,yb,cmap);
end

function majclassify(lr,xb,yb,NUMpts,NUMplot,cmap,titlestr)
  NUMpts2=NUMpts*NUMpts;
  NUMclasses=length(lr.ClassIDs);
  xb=linspace(xb(1),xb(2),NUMpts);
  yb=linspace(yb(1),yb(2),NUMpts);
  [x1,x2]=meshgrid(xb,yb);
  x=[reshape(x1,1,NUMpts2);reshape(x2,1,NUMpts2)];
  predict=sign(lr.w'*x+repmat(lr.b,1,NUMpts2));
  predict(find(predict==0))=1;
  votes=zeros(NUMclasses,NUMpts2);
  for k=1:size(predict,1),
    posvoters=find(predict(k,:)==+1);
    negvoters=find(predict(k,:)==-1);
    votes(lr.posclass(k),posvoters)=votes(lr.posclass(k),posvoters)+1;
    votes(lr.negclass(k),negvoters)=votes(lr.negclass(k),negvoters)+1;
  end;
  [maxval,maxind]=max(votes);
  
  c=reshape(maxind,NUMpts,NUMpts);
  plotdec(NUMplot,c,titlestr,xb,yb,cmap);
end


function maxclassify(lr,xb,yb,NUMpts,NUMplot,cmap,titlestr)
  NUMpts2=NUMpts*NUMpts;
  xb=linspace(xb(1),xb(2),NUMpts);
  yb=linspace(yb(1),yb(2),NUMpts);
  [x1,x2]=meshgrid(xb,yb);
  x=[reshape(x1,1,NUMpts2);reshape(x2,1,NUMpts2)];
  predict=lr.w'*x+repmat(lr.b,1,NUMpts2);
  [maxval,maxind]=max(predict);
  c=reshape(maxind,NUMpts,NUMpts);
  plotdec(NUMplot,c,titlestr,xb,yb,cmap);
end

function svm=LRN1vs1(X,C,y)
  svm.ClassIDs=unique(y);
  NUMclasses=length(svm.ClassIDs);

  k=1;
  for i=1:NUMclasses-1,
    posclass=svm.ClassIDs(i);
    posind=find(y==posclass);
    for j=i+1:NUMclasses,
      negclass=svm.ClassIDs(j);
      negind=find(y==negclass);
      ind=[posind;negind];
      newy=[ones(size(posind));-ones(size(negind))];
      [svm1vs1,x]=COMlinSVM(X(:,ind),C,newy);
      svm.w(:,k)=svm1vs1.w;svm.b(k)=svm1vs1.b;
      svm.posclass(k)=posclass;
      svm.negclass(k)=negclass;
      k=k+1;
    end;
  end;
  svm.b=svm.b';
end

function svm=LRN1vsA(X,C,y)
  NUMpts=length(y);
  svm.ClassIDs=unique(y);
  
  for i=1:length(svm.ClassIDs),
    posclass=svm.ClassIDs(i);
    posind=find(y==posclass);
    negind=find(y~=posclass);
    newy=repmat(-1,NUMpts,1);newy(posind)=1;
    [svm1vsA,x]=COMlinSVM(X,C,newy);
    svm.w(:,i)=svm1vsA.w;svm.b(i)=svm1vsA.b;
  end;
  svm.b=svm.b';
end

function cmap=plotdata(mlr,X,y,plotnum,titlestr,xb,yb)
  figure(2);subplot(2,2,plotnum);cla;
  title(titlestr);
  colstr='rbygwmcrbygwmc';
  
  hold on;
  for k=1:length(mlr.ClassIDs),
    c=colstr(k);
    ind=find(y==mlr.ClassIDs(k));
    h=plot(X(1,ind),X(2,ind),[c,'o'],'MarkerFaceColor',c);
    cmap(k,:)=get(h,'Color');    
  end;
  for k=1:length(mlr.b),
    COMplotplane(xb,yb,mlr.w(:,k),mlr.b(k),[colstr(k),'-']);
  end;
  COMinvertfig;hold off;
end

function plotdec(NUMplot,c,titlestr,xb,yb,cmap)
  figure(1);subplot(2,3,NUMplot);colormap(cmap);
  image(flipud(c));title(titlestr);COMinvertfig;
  [NUMptsy,NUMptsx]=size(c);
  NUMlabels=6;
  xtick=linspace(1,NUMptsx,NUMlabels);
  xlabels=linspace(xb(1),xb(end),NUMlabels);
  set(gca,'XTick',xtick,'XTickLabel',xlabels);
  ytick=linspace(1,NUMptsy,NUMlabels);
  ylabels=linspace(yb(end),yb(1),NUMlabels);
  set(gca,'YTick',ytick,'YTickLabel',ylabels);
end

function [svm,BOOLsuccess]=COMlinSVM(X,C,y)
  [svm,BOOLsuccess]=COMkerSVMpre(X'*X,C,y);
  if (BOOLsuccess), svm.w=X(:,svm.svind)*(svm.alpha.*svm.labels); end;
end
