function LRNkerSVM
  C=100;
  xb=[0.1 5];
  yb=[0.1 5];
  ClassIDs=[1 2];
    
  parms=getparms;
  [X,y]=COMinputmulticlass(xb,yb,ClassIDs);y=2*y-3;
  for i=1:length(parms),
    figure(i);clf;
    subplot(2,2,1);
    plotdata(X,y,parms(i),xb,yb);
    
    K=COMkernelize(X,X,parms(i),1);
    [svm,BOOLsuccess]=COMkerSVMpre(K,C,y);

    subplot(2,2,2);
    distimg=contourplot(X,y,svm.b,svm.alpha,svm.svind,xb,yb,parms(i));
    subplot(2,2,3);imagesc(abs(distimg));axis off;colorbar;
    title('Abs(Distances)');COMinvertfig;
    subplot(2,2,4);imagesc(-sign(distimg));axis off;
    title('Classification');COMinvertfig;
  end;
end

function parms=getparms
  parms(1)=struct('name','Poly','bias',1,'deg',2,'gamma',[]);
  parms(end+1)=struct('name','Poly','bias',1,'deg',5,'gamma',[]);
  parms(end+1)=struct('name','EChi2','bias',[],'deg',[],'gamma',1);
  parms(end+1)=struct('name','RBF','bias',[],'deg',[],'gamma',1);
  parms(end+1)=struct('name','RBF','bias',[],'deg',[],'gamma',0.001);
  parms(end+1)=struct('name','RBF','bias',[],'deg',[],'gamma',100);
end

function distimg=contourplot(X,y,b,alpha,svind,xb,yb,parms)
  posinds=find(y==+1);
  neginds=find(y==-1);
  
  possvinds=svind(find(y(svind)==+1));
  negsvinds=svind(find(y(svind)==-1));
  
  xlim(xb);ylim(yb);title('Decision Boundaries');hold on;
  plot(X(1,posinds),X(2,posinds),'b*');
  plot(X(1,neginds),X(2,neginds),'r*');
  plot(X(1,possvinds),X(2,possvinds),'bs');
  plot(X(1,negsvinds),X(2,negsvinds),'rs');  
  
  NPx=101;NPz=101;NP=NPx*NPz;
  [x,z]=meshgrid(linspace(xb(1),xb(2),NPx),linspace(yb(1),yb(2),NPz));
  pts=[reshape(x,1,NP);reshape(z,1,NP)];
  K=COMkernelize(X(:,svind),pts,parms,0);
  dist=b+(alpha.*y(svind))'*K;
  dist=reshape(dist,NPx,NPz);
  contour(x,z,dist,[+0 +0],'w');
  contour(x,z,dist,[+1 +1],'b--');
  contour(x,z,dist,[-1 -1],'r--');
  COMinvertfig;hold off;
  distimg=flipud(dist);
end

function plotdata(X,y,parms,xb,yb)
  hold on;
  posinds=find(y==+1);
  neginds=find(y==-1);
  xlim(xb);ylim(yb);
  plot(X(1,posinds),X(2,posinds),'b*');
  plot(X(1,neginds),X(2,neginds),'r*');
  titlestr=parms.name;
  if (strcmpi(parms.name,'poly')), 
    titlestr=sprintf('%s Deg %d',titlestr,parms.deg);
  end;
  if (strcmpi(parms.name,'rbf') || strcmpi(parms.name,'echi2')), 
    titlestr=sprintf('%s \\gamma=%0.3f',titlestr,parms.gamma);
  end;
  title(titlestr);
  COMinvertfig;hold off;
end

