function LRNnaivebayes
  C=5;
  xb=[-5 5];
  yb=[-5 5];
  ClassIDs=[1:C];
  
  figure(1);clf;
  [X,y]=COMinputmulticlass(xb,yb,ClassIDs);

  [tx,ty]=meshgrid([xb(1):0.1:xb(2)],[yb(1):0.1:yb(2)]);
  [NUMx,NUMy]=size(tx);
  FEAtst=[reshape(tx,1,NUMx*NUMy);reshape(ty,1,NUMx*NUMy)];
  [model,predict]=COMnaivebayes(X,y,FEAtst,[]);
  [x,trnpredict]=COMnaivebayes(X,y,X,y);

  labels=reshape(predict.labels,NUMx,NUMy);
  
  clf;
  cmap=plotdata(X,y,1,'Data',xb,yb);
  titlestr=sprintf('Train Err = %5.2f%%',100-trnpredict.accuracy);
  cmap=plotdata(X,trnpredict.labels,2,titlestr,xb,yb);
  subplot(2,2,3);colormap(cmap);
  image(flipud(labels));title('Decision Boundaries');COMinvertfig;

  subplot(2,2,4);colormap(cmap);
  NUMclasses=size(predict.probs,1);
  for i=1:NUMclasses,
    p=reshape(predict.probs(i,:),NUMx,NUMy);
    c=i*ones(size(p));c(1:NUMclasses)=[1:NUMclasses];
    mesh(tx,ty,p,c);hold on;
  end;
  title('Posterior p(y|x)');
  COMinvertfig;
end

function cmap=plotdata(X,y,plotnum,titlestr,xb,yb)
  subplot(2,2,plotnum);
  title(titlestr);
  colstr='rbygwmc';
  
  hold on;
  ClassIDs=unique(y);
  for k=1:length(ClassIDs),
    c=colstr(k);
    ind=find(y==ClassIDs(k));
    h=plot(X(1,ind),X(2,ind),[c,'o'],'MarkerFaceColor',c);
    cmap(k,:)=get(h,'Color');
  end;
  xlim(xb);ylim(yb);  
  hold off;
  COMinvertfig;
end
